// CPU version with a large buffer
#include <stdio.h>
#include <string.h>

#define STRSIZE 26*20000	// 520000 chars
#define SIZE 26

int main()
{
	char *buffer;
	int histo[SIZE];  // Count of letters A-Z in buffer, where [0]=A's,
		  	  // [1]=B's, etc.

	printf("Creating data buffer...\n");
	// Allocate buffer
	buffer = (char *)malloc(STRSIZE);
	for (int i = 0; i < 26*20000; i++)
		buffer[i]= 'A' + (i % 26);

	for (int i = 0; i < SIZE; i++)
		histo[i] = 0;

	printf("Counting...\n");
	for (int i = 0; i < strlen(buffer); i++)
		histo[buffer[i]-'A']++;

	for (int i = 0; i < SIZE; i++)
	{
		printf("%c appears %d times.\n", ('A'+i), histo[i]);
	}
	
	free (buffer);
	
 	return 0;
}
